Package com.explodingpixels.widgets.plaf

## Interface ScrollBarSkin

All Known Implementing Classes:
  `ButtonsSeparateScrollBarSkin`, `ButtonsTogetherScrollBarSkin`

    public interface ScrollBarSkin

An interface that allows implementors to control the appearance of a `JScrollBar`.

### Method Summary

All Methods Instance Methods Abstract Methods
`java.awt.Dimension` `getMinimumThumbSize()` The smallest size that the scroll thumb can be.
`java.awt.Dimension` `getPreferredSize()` The preferred size of the painter, which will control the preferred size of the associated `JScrollBar`.
`java.awt.Rectangle` `getScrollThumbBounds()` Gets the current bounds of the scroll thumb, which are controlled by the layout provided by this skin.
`java.awt.Rectangle` `getTrackBounds()` Gets the current bounds of the track, which are controlled by the layout provided by this skin.
`void` `installComponents​(javax.swing.JScrollBar scrollBar)` Called once at the begining of the skin's life cycle.
`void` `installMouseListenersOnButtons​(java.awt.event.MouseListener decrementMoustListener, java.awt.event.MouseListener incrementMouseListener)` Called once at the begining of the skin's life cycle.
`void` `layoutEverything​(javax.swing.JScrollBar scrollBar, ScrollBarOrientation orientation)` Called when scroll bar should be laid out by the skin.
`void` `layoutTrackOnly​(javax.swing.JScrollBar scrollBar, ScrollBarOrientation orientation)` Called when only the track should be laid out by the skin.
`void` `setScrollThumbBounds​(java.awt.Rectangle bounds)` Sets the bounds of the scroll thumb.

### Method Detail

#### installComponents

    void installComponents​(javax.swing.JScrollBar scrollBar)

Called once at the begining of the skin's life cycle. Implementors should add components that will later be controlled in `layoutTrackOnly(JScrollBar, ScrollBarOrientation)` and `layoutEverything(JScrollBar, ScrollBarOrientation)`.

Parameters:
  `scrollBar` - the `JScrollBar` that the skin will be painting.

#### installMouseListenersOnButtons

    void installMouseListenersOnButtons​(java.awt.event.MouseListener decrementMoustListener,
                                        java.awt.event.MouseListener incrementMouseListener)

Called once at the begining of the skin's life cycle. Implementors should attach these mouse listners to the controls that decrement and increment the scroll bar's value.

Parameters:
  `decrementMoustListener` - the `MouseListener` to be notified when a control is pressed that should result in the scroll bar's value decrementing.
  `incrementMouseListener` - the `MouseListener` to be notified when a control is pressed that should result in the scroll bar's value incrementing.

#### layoutTrackOnly

    void layoutTrackOnly​(javax.swing.JScrollBar scrollBar,
                         ScrollBarOrientation orientation)

Called when only the track should be laid out by the skin. This occurs when a `JScrollBar` has been set to `ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS` or `ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS` and the corresponding view is showing all the content. Note that there are, in fact, no restrictions on what this method lays out. That is, if this skin wishes to layout more than just an empty track when there is no content to scroll, it may do so.

Parameters:
  `scrollBar` - the `JScrollBar` that the skin is painting.
  `orientation` - the orientation of the scroll bar.

#### layoutEverything

    void layoutEverything​(javax.swing.JScrollBar scrollBar,
                          ScrollBarOrientation orientation)

Called when scroll bar should be laid out by the skin.

Parameters:
  `scrollBar` - the `JScrollBar` that the skin is painting.
  `orientation` - the orientation of the scroll bar.

#### getMinimumThumbSize

    java.awt.Dimension getMinimumThumbSize()

The smallest size that the scroll thumb can be.

Returns:
  the mimimum size of the scroll thumb.

#### getPreferredSize

    java.awt.Dimension getPreferredSize()

The preferred size of the painter, which will control the preferred size of the associated `JScrollBar`. For vertical scroll bars, this value will drive the width. For horiztonal scroll bars, this value will drive the height.

Returns:
  the preferred size of this painter, and thus the corresponding `JScrollBar`.

#### getScrollThumbBounds

    java.awt.Rectangle getScrollThumbBounds()

Gets the current bounds of the scroll thumb, which are controlled by the layout provided by this skin.

Returns:
  the current bounds of the scroll thumb.

#### setScrollThumbBounds

    void setScrollThumbBounds​(java.awt.Rectangle bounds)

Sets the bounds of the scroll thumb. This method will be called, for example, when the associated `JScrollBar`'s `BoundedRangeModel` is updated.

Parameters:
  `bounds` - the new bounds of the scroll thumb.

#### getTrackBounds

    java.awt.Rectangle getTrackBounds()

Gets the current bounds of the track, which are controlled by the layout provided by this skin. Note that the bounds returned by this method should be the actual scrollable bounds that the scroll thumb can move in. That is, this value should not just return the bounds of the associated `JScrollBar`, but only the bounds that are valid for the scroll thumb to exist in.

Returns:
  the current bounds of the track.